--[[
************************************************************************
Project				: Broker_HitCrit
Author				: zhinjio
Project Revision	: 2.9.0-release
Project Date		: 20090807202706

File				: Broker_HitCrit.lua
Commit Author		: zhinjio
Commit Revision		: 79
Commit Date			: 20090807202706
************************************************************************
Description	:
	Main addon file. 

TODO		:
	Add in disable for vulnerable and low level mobs

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]

-- For now, we need a hack in here to make sure ace3 loads before I do.
-- All hail disembeded libraries and their swift return....
LoadAddOn("Ace3")

HitCrit_VERSION = 1.7

local HitCrit = LibStub( "AceAddon-3.0" ):NewAddon( "HitCrit", "AceEvent-3.0" )
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "HitCrit" )
local AceConfig 		= LibStub("AceConfig-3.0")
local AceConfigReg 		= LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 	= LibStub("AceConfigDialog-3.0")

local addonversion = "2.9.0-release"
local addonauthor = "zhinjio"
local builddate = "20090807202706"

_G["HitCrit"] = HitCrit
addon = HitCrit

local MODNAME = "HitCrit"
local FULLNAME = "Broker_HitCrit"
local modularOptions = {}
local tooltip
local QT = LibStub:GetLibrary( "LibQTip-1.0" )

HitCrit.selCategory = 0
HitCrit.selSchool = 0
HitCrit.selEntry = 0
HitCrit.selEntryName = ""
HitCrit.selSpecific = 0
HitCrit.selSpecificName = ""
HitCrit.superBuffed = false
HitCrit.inVehicle = false
HitCrit.dmgToggleAll = false
HitCrit.healToggleAll = false

HitCrit.selCategory = 0
HitCrit.selSchool = 0
HitCrit.selEntry = 0
HitCrit.selType = "hit"
HitCrit.resetType = 0

local passval

local db
local spellSchools = {
	[1]		= L["physical"],	-- 0x01	1	physical
	[2]		= L["holy"],		-- 0x02	2	holy
	[4]		= L["fire"],		-- 0x04	4	fire
	[8]		= L["nature"],		-- 0x08	8	nature
	[16]	= L["frost"],		-- 0x10	16	frost
	[20]	= L["frostfire"],	-- 0x18	20	frostfire
	[24]	= L["froststorm"],	-- 0x14	24	froststorm
	[32]	= L["shadow"],		-- 0x20	32	shadow
	[40]	= L["shadowstorm"],	-- 0x28	40	shadowstorm
	[64]	= L["arcane"],		-- 0x40	64	arcane
}

local resetExclusionList = {
	-- Druid Lifebloom
	[33763]		= true,		-- LifeBloom, rank 1
	[48450]		= true,		-- LifeBloom, rank 2
	[48451]		= true,		-- LifeBloom, rank 3
	-- Warlock Shadowflame
	[47897]		= true,		-- Shadowflame, rank 1
	[61290]		= true,		-- Shadowflame, rank 2
	-- Argent Tournament spell
	[64077]		= true,		-- Refresh Mount (from Argent Tournament)
}

local superBuffIDs = {
--[[
	-- Turn this on to test if superbuff detection is working properly
	-- Test on Death Knight
	[53136]		= true,		-- Abominable Might			***** Death Knight TEST VALUE ******
]]--
	[60964]		= true,		-- Strength of Wrynn
	[59641]		= true,		-- Warchief's Blessing
	[58549]		= true,		-- Tenacity
	[59911]		= true,		-- Tenacity
	[58361]		= true,		-- The Might of Mograine
	[53642]		= true,		-- The Might of Mograine
	[56330]		= true,		-- Iron's Bane
	[60597]		= true,		-- Blessing of the Crusade
	[58026]		= true,		-- Blessing of the Crusade
	[23505]		= true,		-- Berserking
	[24378]		= true,		-- Berserking
}
local superBuffNames = {}

function HitCrit_Print( msg )
	local _, fh = DEFAULT_CHAT_FRAME:GetFont()
	fh = math.ceil( fh )
	local icon = "\124TInterface\\Addons\\Broker_HitCrit\\icon:" .. fh .. "\124t"
	if ( msg ~= nil ) then
	   if( DEFAULT_CHAT_FRAME ) then
	      DEFAULT_CHAT_FRAME:AddMessage( icon .. " HitCrit: " .. msg, 0.6, 1.0, 1.0 )
	   end
	end
end

function HitCrit_Debug( msg )
	if ( msg ~= nil ) then
		if ( db.options.display.debug ) then
			HitCrit_Print( "DEBUG: " .. msg )
		end
	end
end

function HitCrit_Red( text )
	return "|cffff0000" .. text .. "|r"
end
function HitCrit_Yellow( text )
	return "|cffffff00" .. text .. "|r"
end
function HitCrit_Green( text )
	return "|cff00ff00" .. text .. "|r"
end
function HitCrit_White( text )
	return "|cffffffff" .. text .. "|r"
end
function HitCrit_hit( text)
	return "|cff00ffff" .. text .. "|r"
end
function HitCrit_crit( text)
	return "|cffff8080" .. text .. "|r"
end
function HitCrit_sch( text)
	return "|cffdfa050" .. text .. "|r"
end

function HitCrit:AlertNew( crit, heal, target, spellName, amount )
	local hType, hStr = L["Hit"], L["Hit"]
	local dboa = db.options.alerts
	if ( heal == 1 ) then
		hStr = L["healed"]
		if ( crit == 1 ) then
			hType = L["Critical Heal"]
		else
			hType = L["Heal"]
		end
	else
		if ( crit == 1 ) then
			hType = L["Critical Hit"]
		end
	end
	local outStr = string.format( L["New Record %s! %s %s %s for %d"], hType, spellName, hStr, target, amount )
	if ( dboa.chatframe == true ) then
		HitCrit_Print( outStr )
	end
	if ( dboa.notify == true ) then
		UIErrorsFrame:AddMessage( outStr )
		-- Still need to figure this out
	end
	if ( dboa.sound == true ) then
		-- Still need to figure this out
		PlaySound("LEVELUPSOUND")
	end
	if ( dboa.screenie == true ) then
		Screenshot()
	end
	-- These two could still be present even though they stopped using Parrot/MSBT. Make sure to still
	-- check for the presence of the addon itself.
	if ( ( Parrot ~= nil ) and ( dboa.useparrot == true ) ) then
		if ( ( dboa.parrotarea ~= nil ) and( dboa.parrotarea ~= "" ) ) then
			Parrot:ShowMessage( outStr, dboa.parrotarea )
		else
			Parrot:ShowMessage( outStr )
		end
	end
	if ( ( MikSBT ~= nil ) and ( dboa.usemsbt == true ) ) then
		if ( ( dboa.msbtarea ~= nil ) and( dboa.msbtarea ~= "" ) ) then
			MikSBT.DisplayMessage( outStr, dboa.msbtarea )
		else
			MikSBT.DisplayMessage( outStr )
		end
	end
end

function HitCrit_initHC( entry )
	entry.hit = {}; entry.crit = {}
	entry.total = 0
	entry.num = 0
	for i = 1, 3 do
		entry.hit[i] = {}
		entry.hit[i].value = 0
		entry.hit[i].name = ""
		entry.crit[i] = {}
		entry.crit[i].value = 0
		entry.crit[i].name = ""
	end
end

function HitCrit_initSpellEntry()
	local entry = {}
	entry.effect = ""
	entry.school = 0
	entry.rank = 0
	HitCrit_initHC( entry )
	return entry
end

function HitCrit_CheckInsertAlert( heal, id, hit, crit, dName, effect, sch )
	if ( effect ~= "" ) then
		if ( heal == 1 ) then side = "heal" else side = "damage" end
		if ( db.values[side][id] ) then
			local entry = db.values[side][id]
			-- this value already exists. Compare to current, and replace if needed
			if ( crit ~= 0 ) then
				entry.total = entry.total + crit
				entry.num = entry.num + 1
				entry.numcrit = entry.numcrit + 1
				if ( crit > entry.crit[1].value ) then
					entry.crit[3].value = entry.crit[2].value
					entry.crit[3].name = entry.crit[2].name
					entry.crit[2].value = entry.crit[1].value
					entry.crit[2].name = entry.crit[1].name
					entry.crit[1].value = crit
					entry.crit[1].name = dName
					HitCrit:AlertNew( 1, heal, dName, effect, crit )
				elseif ( crit > entry.crit[2].value ) then
					entry.crit[3].value = entry.crit[2].value
					entry.crit[3].name = entry.crit[2].name
					entry.crit[2].value = crit
					entry.crit[2].name = dName
				elseif ( crit > entry.crit[3].value ) then
					entry.crit[3].value = crit
					entry.crit[3].name = dName
				end
			else
				entry.total = entry.total + hit
				entry.num = entry.num + 1
				if ( hit > entry.hit[1].value ) then
					entry.hit[3].value = entry.hit[2].value
					entry.hit[3].name = entry.hit[2].name
					entry.hit[2].value = entry.hit[1].value
					entry.hit[2].name = entry.hit[1].name
					entry.hit[1].value = hit
					entry.hit[1].name = dName
					HitCrit:AlertNew( 0, heal, dName, effect, hit )
				elseif ( hit > entry.hit[2].value ) then
					entry.hit[3].value = entry.hit[2].value
					entry.hit[3].name = entry.hit[2].name
					entry.hit[2].value = hit
					entry.hit[2].name = dName
				elseif ( hit > entry.hit[3].value ) then
					entry.hit[3].value = hit
					entry.hit[3].name = dName
				end
			end
		else
			-- This could be a previously tracked spell, just with a new rank
			local sName, sRank = GetSpellInfo( id )
			local prevSpellID = 0
			if ( id ~= 0 ) then
				-- sName should match "effect" I believe 
				for k, v in pairs( db.values[side] ) do
					if ( v.effect == sName ) then
						if ( resetExclusionList[k] == true ) then
							-- this is a lifebloom (et al) type spell
							if ( resetExclusionList[id] ) then
								-- the new spell is also on the exclusion list. This is probably a down/uprank of the existing data
								if ( sRank ~= v.rank ) then
									prevSpellID = k
									break
								end
							else
								-- the new spell is NOT excluded. This is probably the "Bloom" effect. So don't exclude
							end
						else
							if ( sRank ~= v.rank ) then
								prevSpellID = k
								break
							else
								-- if we're here, someone is casting a downranked spell. Nub.
							end
						end
					end
				end
			end
			if ( prevSpellID ~= 0 ) then
				db.values[side][prevSpellID] = nil
			end

			-- Otherwise, we've got a new previously untracked value. Record all the info
			db.values[side][id] = {}
			local entry = HitCrit_initSpellEntry()
			entry.effect = effect
			entry.school = sch
			entry.rank = sRank
			entry.hit[1].value = hit
			entry.crit[1].value = crit
			if ( crit ~= 0 ) then
				entry.total = crit
				entry.num = 1
				entry.numcrit = 1
				entry.crit[1].name = dName
				HitCrit:AlertNew( 1, heal, dName, effect, crit )
			else
				entry.total = hit
				entry.num = 1
				entry.numcrit = 0
				entry.hit[1].name = dName
				HitCrit:AlertNew( 0, heal, dName, effect, hit )
			end
			db.values[side][id] = entry
		end
	end
	HitCrit:ChangeLabel()
end

local function amTracking( type )
	-- quick function to see if I'm tracking damage or healing at all
	-- This lets me shortcut out of the CLEU quickly
	local result = false
	if ( type == "damage" ) then
		local tdb = db.options.tracking.damage
		for k, v in pairs( tdb ) do
			if ( tdb[k] == true ) then
				return true
			end
		end
	else
		local tdb = db.options.tracking.healing
		for k, v in pairs( tdb ) do
			if ( tdb[k] == true ) then
				return true
			end
		end
	end
	return result
end

function HitCrit:COMBAT_LOG_EVENT_UNFILTERED( _, _, eType, sGUID, sName, sFlags, dGUID, dName, dFlags, ... )
-- Parameters:
--	event		COMBAT_LOG_EVENT_UNFILTERED
--	timestamp
--	eType		event type (for example, SPELL_DAMAGE)
--	sGUID		source GUID
--	sName		source Name
--	sFlags		source Flags
--	dGUID		destination GUID
--	dName		destination Name
--	dFlags		destination Flags
--
--		The remaining parameters are dependent on eType
--
--		For RANGE_, SPELL_, SPELL_AURA_ and SPELL_PERIODIC_ prefixes, you have the following
--			spellId
--			spellName
--			spellSchool
--
--		Then, for _DAMAGE suffixes:
--			amount
--			overkill
--			school
--			resisted
--			blocked
--			absorbed
--			critical (1 or nil)
--			glancing (1 or nil)
--			crushing (1 or nil)
--
--		Then, for _HEAL suffixes:
--			amount
--			overhealing
--			critical
--
	local effect, id, hit, crit, sch, heal = "", 0, 0, 0, 0, 0
	local targetLevel = UnitLevel( "target" )
	if ( sGUID == HitCrit.GUID ) then
		-- First, check for damage
		if ( amTracking( "damage" ) ) then
			if ( eType == "SWING_DAMAGE" ) then
				local amount, _, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = school
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_DAMAGE" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_DAMAGE" ) then
				local spellID, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, crit, glance, crush = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
		if ( amTracking( "healing" ) ) then
			if ( eType == "SWING_HEAL" ) then
				-- does this event exist?
				local amount, overheal, crit = select( 1, ... )
				id = 0; effect = L["Melee"]; sch = 1; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "RANGE_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_AURA_HEAL" ) then
				-- does this event exist?
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			elseif ( eType == "SPELL_PERIODIC_HEAL" ) then
				local spellID, spellName, spellSchool, amount, overheal, critical = select( 1, ... )
				id = spellID; effect = spellName; sch = spellSchool; heal = 1
				if ( critical == 1 ) then hit = 0; crit = amount else hit = amount; crit = 0 end
			end
		end
	elseif ( ( db.options.tracking.againstMe == true ) and ( dGUID == HitCrit.GUID ) ) then
	end

	local ignoreHit = false
	if ( db.options.tracking.lowlevel == false ) then
		if ( ( HitCrit.level - targetLevel ) >= 7 ) then
			ignoreHit = true
		end
	end
	-- check to make sure we're tracking this school
	local tdb = {}
	if ( heal == 0 ) then tdb = db.options.tracking.damage else tdb = db.options.tracking.healing end
	if ( tdb[sch] == false ) then
		ignoreHit = true
	end
	if ( ( heal == 0 ) and ( dName == HitCrit.me ) ) then
		-- This is an effect like Judgement of the Martyr where hitting someone else transfers some
		-- damage to me. Ignore those
		ignoreHit = true
	end
	if ( ignoreHit == false ) then
		HitCrit_CheckInsertAlert( heal, id, hit, crit, dName, effect, sch )
	end
end

local function HideTooltip()
	tooltip:SetScript( "OnLeave", nil )
	tooltip:Hide()
end

-- Added a static popup for confirmation of delete actions...
StaticPopupDialogs["HC_CONFIRM_RESET_DATA"] = {
	text = "",
	button1 = L["Yes"],
	button2 = L["No"],
	OnAccept = function()
		HitCrit_ResetData()
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1,
	hideOnEscape = 1
}

local function HitCrit_GenerateReportString( category, spell )
	local dbv = db.values[category][ tonumber(spell) ]
	-- format for output:
	-- HitCrit: <Name> casts <effect>(<rank>)(<school>) for <hit> with crit <crit>(critpctg)
	local outString = L["Broker_HitCrit"] .. " : " .. HitCrit.me .. " " .. L["casts"] .. " "
	outString = outString .. dbv["effect"]
	if ( ( dbv.rank ) and ( dbv.rank ~= "" ) ) then
		outString = outString .. "(" .. dbv["rank"] .. ")"
	end
	outString = outString .. "(" .. spellSchools[dbv["school"]] .. ") " .. L["for"] .. " "
	outString = outString .. dbv["hit"][1]["value"] .. " "

	if ( ( dbv.num ~= 0 ) and ( dbv.numcrit ~= 0 ) ) then
		outString = outString .. L["with"] .. " " .. L["Crit"] .. " "
		outString = outString .. dbv["crit"][1]["value"]
		critpctg = string.format( "(%.1f%%)", ( dbv.numcrit / dbv.num * 100 ) )
		outString = outString .. critpctg
	end
	return outString
end

local function HitCrit_MouseHandler( cell, arg, button )
	-- need a couple different effects here.
	-- Normal right click == open config
	-- Normal left click == report into chat frame
	-- Alt left click == reset value
	HitCrit_Debug( "Received .. " .. arg ) 
	if( button == "RightButton" ) then
		HitCrit:ShowConfig()
	elseif ( button == "LeftButton" ) then
		local resetType, resetCat, resetSpecific, hitorcrit = strsplit( "~", arg )
		if ( IsAltKeyDown() ) then
		-- do resetting stuff
			if ( resetCat == "damage" ) then
				HitCrit.selCategory = 1
			end
			if ( hitorcrit == "h" ) then
				HitCrit.selType = "hit"
			elseif ( hitorcrit == "a" ) then
				HitCrit.selType = "all"
			else
				HitCrit.selType = "crit"
			end
			if ( resetType == "2" ) then
				HitCrit_Debug( "Resetting whole category --> " .. resetCat )
				HCBF_ResetCategoryButton()
			elseif ( resetType == "3" ) then
				HitCrit.selSchool = tonumber( resetSpecific )
				HitCrit_Debug( "Resetting school (" .. resetCat .. ") --> " .. resetSpecific )
				HCBF_ResetSchoolButton()
			elseif ( resetType == "4" ) then
				HitCrit.selEntry = tonumber( resetSpecific )
				HitCrit.selEntryName = GetSpellInfo( resetSpecific )
				HitCrit_Debug( "Resetting spell (" .. resetCat .. ") --> " .. resetSpecific )
				if ( hitorcrit == "a" ) then
					HCBF_ResetEntryButton()
				else
					HCBF_ResetTopEntryButton()
				end
			else
				HitCrit_Debug( "ResetType is " .. resetType )
			end
		else
			HitCrit_Debug( "Chatframe reporting" )
			-- I can only do chatframe reporting for specific strings, not categories or schools
			if ( resetType == "4" ) then
				-- do chatframe stuff
				HitCrit_Debug( "correct reset type" )
				local chatReportString = HitCrit_GenerateReportString( resetCat, resetSpecific )
				if ( ChatFrameEditBox:IsVisible() ) then
					local currentText = ChatFrameEditBox:GetText()
					ChatFrameEditBox:SetText( currentText .. chatReportString )
				else
					ChatFrameEditBox:Show()
					ChatFrameEditBox:SetText( chatReportString )
				end
			end
		end
	end
		
end

local function drawTooltip()
	tooltip:Hide()
	tooltip:Clear()

	local t = {}
	local numCols = 3
	t[1] = "LEFT"
	if ( db.options.display.avg ) then numCols = numCols + 1; table.insert( t, "RIGHT" ) end
	if ( db.options.display.hit ) then numCols = numCols + 1; table.insert( t, "RIGHT" ) end
	if ( db.options.display.crit ) then numCols = numCols + 1; table.insert( t, "RIGHT" ) end
	if ( db.options.display.enemyName ) then numCols = numCols + 1; table.insert( t, "RIGHT" ) end
	tooltip:SetColumnLayout( numCols, unpack( t ) )

	local lineNum = tooltip:AddHeader( "b" )
	tooltip:SetCell( lineNum, 1, HitCrit_White( L["Broker_HitCrit"] ), "CENTER", numCols )
	local colIndex = 0
	local t = {}
	if ( db.options.display.type ) then
		-- sort by damage school
		local schools = {}; schools.damage = {}; schools.healing = {}
		for k, v in pairs( spellSchools ) do schools.damage[k] = {}; schools.healing[k] = {} end
		for k, v in pairs( db.values["damage"] ) do
			schools.damage[v.school][k] = true
		end
		for k, v in pairs( db.values["heal"] ) do
			schools.healing[v.school][k] = true
		end
		-- damage block
		lineNum = tooltip:AddLine( " " )
		tooltip:SetCell( lineNum, 1, HitCrit_Red( "  " .. L["Damage"] ), "LEFT", numCols )
		tooltip:SetCellScript( lineNum, 1, "OnMouseDown", HitCrit_MouseHandler, "2~damage~0~h" )
		wipe(t)
		table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
		if ( db.options.display.avg ) then table.insert( t, HitCrit_White( L["Avg"] ) ) end
		if ( db.options.display.hit ) then table.insert( t, HitCrit_White( L["Hit"] ) ) end
		if ( db.options.display.crit ) then table.insert( t, HitCrit_White( L["Crit"] .. "(%)" ) ) end
		if ( db.options.display.enemyName ) then table.insert( t, HitCrit_White( L["Against"] ) ) end
		tooltip:AddLine( unpack( t ) )
		for k, v in pairs( spellSchools ) do
			if ( next( schools.damage[k] ) ~= nil ) then
				lineNum = tooltip:AddLine( " " )
				passval = 
				tooltip:SetCell( lineNum, 1, HitCrit_sch( "    " .. v ), "LEFT", numCols )
				tooltip:SetCellScript( lineNum, 1, "OnMouseDown",
					HitCrit_MouseHandler, "3~damage~" .. k .. "~h" )
				for m, u in pairs( schools.damage[k] ) do
					local i = db.values["damage"][m]
					local e, h, c, a = i.effect, i.hit[1].value, i.crit[1].value, floor( i.total / i.num )
					local cp = ""
					if ( ( i.num ~= 0 ) and ( i.numcrit ~= 0 ) ) 
						then cp = string.format( "(%.1f%%)", ( i.numcrit / i.num * 100 ) )
					end
					if ( i.num == 0 ) then a = " " end
					lineNum = tooltip:AddLine( "b" )
					local colIndex = 1
					tooltip:SetCell( lineNum, colIndex, HitCrit_Yellow( "      " .. e ), "LEFT", 1 )
					tooltip:SetCellScript( lineNum, 1, "OnMouseDown", 
						HitCrit_MouseHandler, "4~damage~" .. m .. "~a" )
					if ( db.options.display.avg ) then
						colIndex = colIndex + 1
						tooltip:SetCell( lineNum, colIndex, HitCrit_Yellow( a ), "RIGHT", 1 )
					end
					if ( db.options.display.hit ) then
						colIndex = colIndex + 1
						tooltip:SetCell( lineNum, colIndex, HitCrit_hit( h ), "RIGHT", 1 )
						tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
							HitCrit_MouseHandler, "4~damage~" .. m .. "~h" )
					end
					if ( db.options.display.crit ) then
						colIndex = colIndex + 1
						tooltip:SetCell( lineNum, colIndex, HitCrit_crit( c .. cp ), "RIGHT", 1 )
						tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
							HitCrit_MouseHandler, "4~damage~" .. m .. "~c" )
					end
					if ( db.options.display.enemyName ) then 
						colIndex = colIndex + 1
						if ( c ~= 0 ) then
							tooltip:SetCell( lineNum, colIndex, HitCrit_crit( i.crit[1].name ), "RIGHT", 1 )
						else
							tooltip:SetCell( lineNum, colIndex, HitCrit_hit( i.hit[1].name ), "RIGHT", 1 )
						end
					end
				end
			end
		end
		-- healing block
		lineNum = tooltip:AddLine( " " )
		tooltip:SetCell( lineNum, 1, HitCrit_Green( "  " .. L["Healing"] ), "LEFT", numCols, passval )
		tooltip:SetCellScript( lineNum, 1, "OnMouseDown", 
			HitCrit_MouseHandler, "2~heal~0~h" )
		wipe(t)
		table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
		if ( db.options.display.avg ) then table.insert( t, HitCrit_White( L["Avg"] ) ) end
		if ( db.options.display.hit ) then table.insert( t, HitCrit_White( L["Hit"] ) ) end
		if ( db.options.display.crit ) then table.insert( t, HitCrit_White( L["Crit"] .. "(%)" ) ) end
		if ( db.options.display.enemyName ) then table.insert( t, HitCrit_White( L["Against"] ) ) end
		tooltip:AddLine( unpack( t ) )
		for k, v in pairs( spellSchools ) do
			if ( next( schools.healing[k] ) ~= nil ) then
				lineNum = tooltip:AddLine( " " )
				tooltip:SetCell( lineNum, 1, HitCrit_sch( "    " .. v ), "LEFT", numCols )
				tooltip:SetCellScript( lineNum, 1, "OnMouseDown", 
					HitCrit_MouseHandler, "3~heal~" .. k .. "~h" )
				for m, n in pairs( schools.healing[k] ) do
					local i = db.values["heal"][m]
					local e, h, c, a = i.effect, i.hit[1].value, i.crit[1].value, floor( i.total / i.num )
					local cp = ""
					if ( ( i.num ~= 0 ) and ( i.numcrit ~= 0 ) ) 
						then cp = string.format( "(%.1f%%)", ( i.numcrit / i.num * 100 ) )
					end
					if ( i.num == 0 ) then a = " " end
					lineNum = tooltip:AddLine( " " )
					colIndex = 1
					tooltip:SetCell( lineNum, colIndex, HitCrit_Yellow( "      " .. e ), "LEFT", 1 )
					tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
						HitCrit_MouseHandler, "4~heal~" .. m .. "~a" )
					if ( db.options.display.avg ) then
						colIndex = colIndex + 1
						tooltip:SetCell( lineNum, colIndex, HitCrit_Yellow( a ), "RIGHT", 1 )
					end
					if ( db.options.display.hit ) then
						colIndex = colIndex + 1
						tooltip:SetCell( lineNum, colIndex, HitCrit_hit( h ), "RIGHT", 1 )
						tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
							HitCrit_MouseHandler, "4~heal~" .. m .. "~h" )
					end
					if ( db.options.display.crit ) then
						colIndex = colIndex + 1
						tooltip:SetCell( lineNum, colIndex, HitCrit_crit( c .. cp ), "RIGHT", 1 )
						tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
							HitCrit_MouseHandler, "4~heal~" .. m .. "~c" )
					end
					if ( db.options.display.enemyName ) then 
						colIndex = colIndex + 1
						if ( c ~= 0 ) then
							tooltip:SetCell( lineNum, colIndex, HitCrit_crit( i.crit[1].name ), "RIGHT", 1 )
						else
							tooltip:SetCell( lineNum, colIndex, HitCrit_hit( i.hit[1].name ), "RIGHT", 1 )
						end
					end
				end
			end
		end
	else
		-- damage header lines
		lineNum = tooltip:AddLine( " " )
		tooltip:SetCell( lineNum, 1, HitCrit_Red( "  " .. L["Damage"] ), "LEFT", numCols )
		tooltip:SetCellScript( lineNum, 1, "OnMouseDown", 
			HitCrit_MouseHandler, "2~damage~0~h" )
		table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
		if ( db.options.display.avg ) then table.insert( t, HitCrit_White( L["Avg"] ) ) end
		if ( db.options.display.hit ) then table.insert( t, HitCrit_White( L["Hit"] ) ) end
		if ( db.options.display.crit ) then table.insert( t, HitCrit_White( L["Crit"] .. "(%)" ) ) end
		if ( db.options.display.enemyName ) then table.insert( t, HitCrit_White( L["Against"] ) ) end
		tooltip:AddLine( unpack( t ) )
		for k, v in pairs( db.values["damage"] ) do
			local e, h, c, a = v.effect, v.hit[1].value, v.crit[1].value, floor( v.total / v.num )
			local cp = ""
			if ( ( v.num ~= 0 ) and ( v.numcrit ~= 0 ) ) 
				then cp = string.format( "(%.1f%%)", ( v.numcrit / v.num * 100 ) )
			end
			if ( v.num == 0 ) then a = " " end
			lineNum = tooltip:AddLine( " " )
			colIndex = 1
			passval = 
			tooltip:SetCell( lineNum, colIndex, HitCrit_Yellow( "    " .. e ), "LEFT", 1 )
			tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
				HitCrit_MouseHandler, "4~heal~" .. k .. "~a" )
			if ( db.options.display.avg ) then
				colIndex = colIndex + 1
				tooltip:SetCell( lineNum, colIndex, HitCrit_Yellow( a ), "RIGHT", 1 )
			end
			if ( db.options.display.hit ) then
				colIndex = colIndex + 1
				tooltip:SetCell( lineNum, colIndex, HitCrit_hit( h ), "RIGHT", 1 )
				tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
					HitCrit_MouseHandler, "4~heal~" .. k .. "~h" )
			end
			if ( db.options.display.crit ) then
				colIndex = colIndex + 1
				tooltip:SetCell( lineNum, colIndex, HitCrit_crit( c .. cp ), "RIGHT", 1 )
				tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
					HitCrit_MouseHandler, "4~heal~" .. k .. "~c" )
			end
			if ( db.options.display.enemyName ) then 
				colIndex = colIndex + 1
				if ( c ~= 0 ) then
					tooltip:SetCell( lineNum, colIndex, HitCrit_crit( v.crit[1].name ), "RIGHT", 1 )
				else
					tooltip:SetCell( lineNum, colIndex, HitCrit_hit( v.hit[1].name ), "RIGHT", 1 )
				end
			end
		end
		-- healing header lines
		lineNum = tooltip:AddLine( " " )
		tooltip:SetCell( lineNum, 1, HitCrit_Green( "  " .. L["Healing"] ), "LEFT", numCols )
		tooltip:SetCellScript( lineNum, 1, "OnMouseDown", 
			HitCrit_MouseHandler, "2~heal~0~h" )
		wipe(t)
		table.insert( t, HitCrit_White( "    " .. L["Effect"] ) )
		if ( db.options.display.avg ) then table.insert( t, HitCrit_White( L["Avg"] ) ) end
		if ( db.options.display.hit ) then table.insert( t, HitCrit_White( L["Hit"] ) ) end
		if ( db.options.display.crit ) then table.insert( t, HitCrit_White( L["Crit"] .. "(%)" ) ) end
		if ( db.options.display.enemyName ) then table.insert( t, HitCrit_White( L["Against"] ) ) end
		tooltip:AddLine( unpack( t ) )
		-- loop through healing
		for k, v in pairs( db.values["heal"] ) do
			local e, h, c, a = v.effect, v.hit[1].value, v.crit[1].value, floor( v.total / v.num )
			local cp = ""
			if ( ( v.num ~= 0 ) and ( v.numcrit ~= 0 ) ) 
				then cp = string.format( "(%.1f%%)", ( v.numcrit / v.num * 100 ) )
			end
			if ( v.num == 0 ) then a = " " end
			lineNum = tooltip:AddLine( " " )
			colIndex = 1
			tooltip:SetCell( lineNum, colIndex, HitCrit_Yellow( "    " .. e ), "LEFT", 1 )
			tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
				HitCrit_MouseHandler, "4~heal~" .. k .. "~a" )
			if ( db.options.display.avg ) then
				colIndex = colIndex + 1
				tooltip:SetCell( lineNum, colIndex, HitCrit_Yellow( a ), "RIGHT", 1 )
			end
			if ( db.options.display.hit ) then
				colIndex = colIndex + 1
				tooltip:SetCell( lineNum, colIndex, HitCrit_hit( h ), "RIGHT", 1 )
				tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
					HitCrit_MouseHandler, "4~heal~" .. k .. "~h" )
			end
			if ( db.options.display.crit ) then
				colIndex = colIndex + 1
				tooltip:SetCell( lineNum, colIndex, HitCrit_crit( c .. cp ), "RIGHT", 1 )
				tooltip:SetCellScript( lineNum, colIndex, "OnMouseDown", 
					HitCrit_MouseHandler, "4~heal~" .. k .. "~c" )
			end
			if ( db.options.display.enemyName ) then 
				colIndex = colIndex + 1
				if ( c ~= 0 ) then
					tooltip:SetCell( lineNum, colIndex, HitCrit_crit( v.crit[1].name ), "RIGHT", 1, passval )
				else
					tooltip:SetCell( lineNum, colIndex, HitCrit_hit( v.hit[1].name ), "RIGHT", 1, passval )
				end
			end
		end
	end
	-- Add menu items
	tooltip:AddLine(" ")
	lineNum = tooltip:AddLine( "c" )
	tooltip:SetCell( lineNum, 1, HitCrit_Yellow( L["Left-click for Report values in chat"] ), "LEFT", numCols )
	lineNum = tooltip:AddLine( "d" )
	tooltip:SetCell( lineNum, 1, HitCrit_Yellow( L["Alt-Left-click to delete values"] ), "LEFT", numCols )
	lineNum = tooltip:AddLine( "e" )
	tooltip:SetCell( lineNum, 1, HitCrit_Yellow( L["Right-click for Configuration"] ), "LEFT", numCols )
end

local LDB = LibStub( "LibDataBroker-1.1" )
local launcher = LDB:NewDataObject( MODNAME, {
	type = "data source",
	text = " ",
	label = FULLNAME,
	icon = "Interface\\Addons\\Broker_HitCrit\\icon",
	OnClick = function(clickedframe, button)
				if button == "RightButton" then
					HitCrit:ShowConfig()
				else
					-- nothing anymore
				end
	end,
	OnEnter = function ( self )
		tooltip = QT:Acquire( "HitCritTT", 7, "LEFT", "CENTER", "RIGHT", "CENTER", "RIGHT", "CENTER", "RIGHT" )
		tooltip:SetScale( db.options.display.tipscale )
		drawTooltip()
		tooltip:SetAutoHideDelay( db.options.display.autoHideDelay, self )
		tooltip:EnableMouse()
		tooltip:Show()
	end,
	OnLeave = function()
		-- apparently some LDB displays pitch a fit when your launcher
		-- has an onenter, but no onleave. Pshaw, I say.
		return
	end,
} )

function HitCrit_upgradeDB()
	local olddb = HitCrit.db.factionrealm[HitCrit.me]
	-- This checks the current DB version the person has, and upgrades as necessary
	if not ( olddb.options.display.dbVersion ) then
		-- They have the original version
		local values = {}; values["damage"] = {}; values["heal"] = {}
		local side = "damage"
		for k, v in pairs( olddb.values ) do
			HitCrit_Debug( "id/h/c/dmg/sch/eff = "..k.."/"..v.hit.."/"..v.crit.."/"..
				v.dmg.."/"..v.school.."/"..v.effect )
			if ( v.dmg == 1 ) then side = "damage" else side = "heal" end
			local entry = HitCrit_initSpellEntry()
			_, sRank = GetSpellInfo( k )
			entry.school = v.school
			entry.effect = v.effect
			entry.rank = sRank
			entry.total = 0
			entry.num = 0
			entry.hit[1].value = v.hit
			entry.crit[1].value = v.crit
			if ( v.hit == 0 ) then entry.hit[1].name = "" else entry.hit[1].name = v.target end
			if ( v.crit == 0 ) then entry.crit[1].name = "" else entry.crit[1].name = v.target end
			values[side][k] = entry
		end
		olddb.values = nil
		olddb.values = values
		olddb.options.display.dbVersion = "1.1"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.1" ) )
	end
	if ( olddb.options.display.dbVersion == "1.1" ) then
		olddb.options.tracking.lowlevel = false
		olddb.options.display.dbVersion = "1.2"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.2" ) )
	end
	if ( olddb.options.display.dbVersion == "1.2" ) then
		olddb.options.display.avg = true
		olddb.options.display.dbVersion = "1.3"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.3" ) )
	end
	if ( olddb.options.display.dbVersion == "1.3" ) then
		olddb.options.display.fontsize = nil
		olddb.options.display.tipscale = 1
		olddb.options.display.dbVersion = "1.4"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.4" ) )
	end
	if ( olddb.options.display.dbVersion == "1.4" ) then
		olddb.options.alerts.screenie = false
		olddb.options.display.dbVersion = "1.5"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.5" ) )
	end
	if ( olddb.options.display.dbVersion == "1.5" ) then
		olddb.options.display.debug = false
		olddb.options.display.dbVersion = "1.6"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.6" ) )
	end
	if ( olddb.options.display.dbVersion == "1.6" ) then
		-- reset totals for each damage and healing entry, and add in the numcrit field
		for k, v in pairs( olddb.values["heal"] ) do
			v.total = 0
			v.num = 0
			v.numcrit = 0
		end
		for k, v in pairs( olddb.values["damage"] ) do
			v.total = 0
			v.num = 0
			v.numcrit = 0
		end
		olddb.options.display.debug = false
		olddb.options.display.dbVersion = "1.7"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.7" ) )
	end
	if ( olddb.options.display.dbVersion == "1.7" ) then
		olddb.options.display.label = false
		olddb.options.display.labelHeal = false
		olddb.options.display.dbVersion = "1.8"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.8" ) )
	end
	if ( olddb.options.display.dbVersion == "1.8" ) then
		olddb.options.alerts.useparrot = false
		olddb.options.alerts.parrotarea = ""
		olddb.options.alerts.usemsbt = false
		olddb.options.alerts.msbtarea = ""
		olddb.options.display.dbVersion = "1.9"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "1.9" ) )
	end
	if ( olddb.options.display.dbVersion == "1.9" ) then
		olddb.options.tracking.healing = nil
		olddb.options.tracking.healing = {}
		for k, v in pairs( spellSchools ) do
			olddb.options.tracking.healing[k] = true
		end
		olddb.options.tracking.damage = nil
		olddb.options.tracking.damage = {}
		for k, v in pairs( spellSchools ) do
			olddb.options.tracking.damage[k] = true
		end
		olddb.options.display.dbVersion = "2.0"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "2.0" ) )
	end
	if ( olddb.options.display.dbVersion == "2.0" ) then
		olddb.options.alerts.superbuffnotify = false
		olddb.options.display.dbVersion = "2.1"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "2.1" ) )
	end
	if ( olddb.options.display.dbVersion == "2.1" ) then
		olddb.options.tracking.spdetect = true
		olddb.options.display.dbVersion = "2.2"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "2.2" ) )
	end
	if ( olddb.options.display.dbVersion == "2.2" ) then
		olddb.options.display.labelDmg = false
		olddb.options.display.dbVersion = "2.3"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "2.3" ) )
	end
	if ( olddb.options.display.dbVersion == "2.3" ) then
		olddb.options.display.autoHideDelay = .25
		olddb.options.display.dbVersion = "2.4"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "2.4" ) )
	end
	if ( olddb.options.display.dbVersion == "2.4" ) then
		olddb.options.display.autoHideDelay = .1
		olddb.options.display.dbVersion = "2.5"
		HitCrit_Print( string.format( L["Database upgraded to %s"], "2.5" ) )
	end
end

function HitCrit:ChangeLabel()
	-- going to go with the following format:
	-- 		topdmghit(topdmgcrit)/tophealhit(tophealcrit)
	--
	-- default value
	local dmgtext = ""
	local healtext = ""
	local blort = 0
	launcher.text = ""
	local dbd = db.options.display
	if ( dbd.label == true ) then
		-- by default, we display damage
		local tophit, topcrit = 0, 0
		if ( dbd.labelHeal == true ) then
			for k, v in pairs( db.values["heal"] ) do
				if ( v.hit[1].value > tophit ) then tophit = v.hit[1].value end
				if ( v.crit[1].value > topcrit ) then topcrit = v.crit[1].value end
			end
			healtext = HitCrit_Green( tophit .. "(" .. topcrit .. ")" )
			blort = blort + 1
		end
		tophit, topcrit = 0, 0
		if ( dbd.labelDmg == true ) then
			for k, v in pairs( db.values["damage"] ) do
				if ( v.hit[1].value > tophit ) then tophit = v.hit[1].value end
				if ( v.crit[1].value > topcrit ) then topcrit = v.crit[1].value end
			end
			dmgtext = HitCrit_Red( tophit .. "(" .. topcrit .. ")" )
			blort = blort + 1
		end
		if ( blort == 1 ) then
			if ( dbd.labelHeal == true ) then
				launcher.text = healtext
			else
				launcher.text = dmgtext
			end
		elseif( blort == 2 ) then
			launcher.text = dmgtext .. "/" .. healtext
		end
	end
end

local alertOptions = nil
local displayOptions = nil
local trackingOptions = nil
local options = nil

-- options stuff
local function giveTracking()
	if (not trackingOptions) then
		trackingOptions = {
			order = 2,
			type = "group",
			name = L["Tracking Options"],
			desc = L["TRACKING_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 21,
					type	= "header",
					name	= L["Tracking Options"],
				},
				desc = {
					order	= 22,
					type	= "description",
					name	= L["TRACKING_OPTIONS_DESC"],
				},
				pvp = {
					order	= 23,
					type	= "toggle",
					name	= L["Track PvP"],
					desc	= L["TRACK_PVP_DESC"],
					get		= function() return db.options.tracking.pvp end,
					set		= function() db.options.tracking.pvp = not db.options.tracking.pvp end,
					disabled = true,
				},
				againstMe = {
					order	= 24,
					type	= "toggle",
					name	= L["Track Hits Against Me"],
					desc	= L["TRACK_AGAINSTME_DESC"],
					get		= function() return db.options.tracking.againstMe end,
					set		= function() db.options.tracking.againstMe = not db.options.tracking.againstMe end,
					disabled = true,
				},
				environmental = {
					order	= 27,
					type	= "toggle",
					name	= L["Track Environmental"],
					desc	= L["TRACK_ENVIRONMENTAL_DESC"],
					get		= function() return db.options.tracking.environmental end,
					set		= function() db.options.tracking.environmental = not db.options.tracking.environmental end,
					disabled = true,
				},
				vulnerable = {
					order	= 28,
					type	= "toggle",
					name	= L["Track Vulnerable"],
					desc	= L["TRACK_VULNERABLE_DESC"],
					get		= function() return db.options.tracking.vulnerable end,
					set		= function() db.options.tracking.vulnerable = not db.options.tracking.vulnerable end,
					disabled = true,
				},
				lowlevel = {
					order	= 29,
					type	= "toggle",
					name	= L["Track Low Level"],
					desc	= L["TRACK_LOWLEVEL_DESC"],
					get		= function() return db.options.tracking.lowlevel end,
					set		= function() db.options.tracking.lowlevel = not db.options.tracking.lowlevel end,
				},
				spdetect = {
					order	= 30,
					type	= "toggle",
					name	= L["Detect Superbuffs"],
					desc	= L["TRACK_DETECT_SP"],
					get		= function() return db.options.tracking.spdetect end,
					set		= function()
								db.options.tracking.spdetect = not db.options.tracking.spdetect
								if ( db.options.tracking.spdetect == true ) then
									HitCrit:RegisterEvent( "UNIT_AURA" )
									HitCrit:RegisterEvent( "UNIT_ENTERED_VEHICLE" )
									HitCrit:RegisterEvent( "UNIT_EXITED_VEHICLE" )
								else
									HitCrit:UnregisterEvent( "UNIT_AURA" )
									HitCrit:UnregisterEvent( "UNIT_ENTERED_VEHICLE" )
									HitCrit:UnregisterEvent( "UNIT_EXITED_VEHICLE" )
								end
							  end,
				},
				header2 = {
					order	= 100,
					type	= "header",
					name	= L["Damage Schools"],
				},
				desc2 = {
					order	= 101,
					type	= "description",
					name	= L["DMG_SCHOOLS_DESC"],
				},
				damage = {
					order	= 102,
					type	= "toggle",
					name	= L["Global Damage Toggle"],
					desc	= L["DMG_GLOBAL_TOGGLE_DESC"],
					get		= function() return HitCrit.dmgToggleAll end,
					set		= function()
						HitCrit.dmgToggleAll = not HitCrit.dmgToggleAll
						local newsetvalue = true
						if ( HitCrit.dmgToggleAll == true ) then
							newsetvalue = true
						else
							newsetvalue = false
						end
						for k, v in pairs( spellSchools ) do
							db.options.tracking.damage[k] = newsetvalue
						end
					end,
				},
				header3 = {
					order	= 200,
					type	= "header",
					name	= L["Healing Schools"],
				},
				desc3 = {
					order	= 201,
					type	= "description",
					name	= L["HEAL_SCHOOLS_DESC"],
				},
				healing = {
					order	= 202,
					type	= "toggle",
					name	= L["Global Healing Toggle"],
					desc	= L["HEAL_GLOBAL_TOGGLE_DESC"],
					get		= function() return HitCrit.healToggleAll end,
					set		= function()
						HitCrit.healToggleAll = not HitCrit.healToggleAll
						local newsetvalue = true
						if ( HitCrit.healToggleAll == true ) then
							newsetvalue = true
						else
							newsetvalue = false
						end
						for k, v in pairs( spellSchools ) do
							db.options.tracking.healing[k] = newsetvalue
						end
					end,
				},
			},
		}
	end
	-- loops to add in the spell school stuff
	for k, v in pairs( spellSchools ) do
		local dmgname = "dmgsch" .. k
		local healname = "healdch" .. k
		-- damage
		trackingOptions.args[dmgname] = {
			order	= ( 103 + k ),
			type	= "toggle",
			name	= v,
			desc	= v,
			get		= function() return db.options.tracking.damage[k] end,
			set		= function()
				db.options.tracking.damage[k] = not db.options.tracking.damage[k]
				local result = true
				for k, v in pairs( spellSchools ) do
					if ( db.options.tracking.damage[k] == false ) then
						result = false
						break
					end
				end
				HitCrit.dmgToggleAll = result
			end,
		}
		trackingOptions.args[healname] = {
			order	= ( 203 + k ),
			type	= "toggle",
			name	= v,
			desc	= v,
			get		= function() return db.options.tracking.healing[k] end,
			set		= function()
				db.options.tracking.healing[k] = not db.options.tracking.healing[k]
				local result = true
				for k, v in pairs( spellSchools ) do
					if ( db.options.tracking.healing[k] == false ) then
						result = false
						break
					end
				end
				HitCrit.healToggleAll = result
			end,
		}
	end
	return trackingOptions
end

local function giveDisplay()
	if (not displayOptions) then
		displayOptions = {
			order = 3,
			type = "group",
			name = L["Display Options"],
			desc = L["DISPLAY_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 31,
					type	= "header",
					name	= L["Display Options"],
				},
				desc = {
					order	= 32,
					type	= "description",
					name	= L["DISPLAY_OPTIONS_DESC"],
				},
				avg = {
					order	= 33,
					type	= "toggle",
					name	= L["Display Avg"],
					desc	= L["DISPLAY_AVG_DESC"],
					get		= function() return db.options.display.avg end,
					set		= function() db.options.display.avg = not db.options.display.avg end,
				},
				hit = {
					order	= 34,
					type	= "toggle",
					name	= L["Display Hit"],
					desc	= L["DISPLAY_HIT_DESC"],
					get		= function() return db.options.display.hit end,
					set		= function() db.options.display.hit = not db.options.display.hit end,
				},
				crit = {
					order	= 35,
					type	= "toggle",
					name	= L["Display Crit"],
					desc	= L["DISPLAY_CRIT_DESC"],
					get		= function() return db.options.display.crit end,
					set		= function() db.options.display.crit = not db.options.display.crit end,
				},
				enemyName = {
					order	= 36,
					type	= "toggle",
					name	= L["Display Enemy Name"],
					desc	= L["DISPLAY_ENEMYNAME_DESC"],
					get		= function() return db.options.display.enemyName end,
					set		= function() db.options.display.enemyName = not db.options.display.enemyName end,
				},
				school = {
					order	= 37,
					type	= "toggle",
					name	= L["Sort by School"],
					desc	= L["DISPLAY_SORTSCHOOL_DESC"],
					get		= function() return db.options.display.type end,
					set		= function() db.options.display.type = not db.options.display.type end,
				},
				tooltipscale = {
					order	= 41,
					type	= "range",
					name	= L["Tooltip Scale"],
					desc	= L["TOOLTIP_SCALE_DESC"],
					min		= .7,
					max		= 1.3,
					step	= .05,
					bigStep = .05,
					get		= function() return db.options.display.tipscale end,
					set		= function( info, v ) 
								db.options.display.tipscale = v
								tooltip:SetScale( v )
							  end,
				},
				header2 = {
					order	= 100,
					type	= "header",
					name	= L["LDB Text Display Options"],
				},
				desc2 = {
					order	= 101,
					type	= "description",
					name	= L["LDBDISPLAY_OPTIONS_DESC"],
				},
				label = {
					order	= 102,
					type	= "toggle",
					name	= L["Display Top Values"],
					desc	= L["DISPLAY_LABEL_DESC"],
					get		= function() return db.options.display.label end,
					set		= function()
								db.options.display.label = not db.options.display.label
								HitCrit:ChangeLabel()
							  end,									
				},
				labelHeal = {
					order	= 103,
					type	= "toggle",
					name	= L["Display Heal in Label"],
					desc	= L["DISPLAY_LABELHEAL_DESC"],
					get		= function() return db.options.display.labelHeal end,
					set		= function()
								db.options.display.labelHeal = not db.options.display.labelHeal
								HitCrit:ChangeLabel()
							  end,
					disabled	= function() return not db.options.display.label end,
				},
				labelDmg = {
					order	= 104,
					type	= "toggle",
					name	= L["Display Dmg in Label"],
					desc	= L["DISPLAY_LABELDMG_DESC"],
					get		= function() return db.options.display.labelDmg end,
					set		= function()
								db.options.display.labelDmg = not db.options.display.labelDmg
								HitCrit:ChangeLabel()
							  end,
					disabled	= function() return not db.options.display.label end,
				},
				header3 = {
					order	= 200,
					type	= "header",
					name	= L["Miscellaneous Display Options"],
				},
				desc3 = {
					order	= 201,
					type	= "description",
					name	= L["MISCDISPLAY_OPTIONS_DESC"],
				},
				debug = {
					order	= 202,
					type	= "toggle",
					name	= L["Display Debug"],
					desc	= L["DISPLAY_DEBUG_DESC"],
					get		= function() return db.options.display.debug end,
					set		= function() db.options.display.debug = not db.options.display.debug end,
				},
				autoHideDelay = {
					order	= 203,
					type	= "range",
					name	= L["Tooltip Auto-hide Delay"],
					desc	= L["TOOLTIP_DELAY_DESC"],
					min		= .1,
					max		= 2,
					step	= .1,
					bigStep = .1,
					get		= function() return db.options.display.autoHideDelay end,
					set		= function( info, v ) 
								db.options.display.autoHideDelay = v
							  end,
				},
			},
		}
	end
	return displayOptions
end

local function giveAlert()
	if (not alertOptions) then
		alertOptions = {
			order = 4,
			type = "group",
			name = L["Alert Options"],
			desc = L["ALERT_OPTIONS_DESC"],
			args = {
				header1 = {
					order	= 41,
					type	= "header",
					name	= L["Alert Options"],
				},
				desc = {
					order	= 42,
					type	= "description",
					name	= L["ALERT_OPTIONS_DESC"],
				},
				sound = {
					order	= 43,
					type	= "toggle",
					name	= L["Alert with Sound"],
					desc	= L["ALERT_SOUND_DESC"],
					get		= function() return db.options.alerts.sound end,
					set		= function() db.options.alerts.sound = not db.options.alerts.sound end,
				},
				notify = {
					order	= 44,
					type	= "toggle",
					name	= L["Alert with Notify"],
					desc	= L["ALERT_NOTIFY_DESC"],
					get		= function() return db.options.alerts.notify end,
					set		= function() db.options.alerts.notify = not db.options.alerts.notify end,
				},
				chatframe = {
					order	= 45,
					type	= "toggle",
					name	= L["Alert in Chat Frame"],
					desc	= L["ALERT_CHATFRAME_DESC"],
					get		= function() return db.options.alerts.chatframe end,
					set		= function() db.options.alerts.chatframe = not db.options.alerts.chatframe end,
				},
				screenie = {
					order	= 46,
					type	= "toggle",
					name	= L["Take Screenshot"],
					desc	= L["ALERT_SCREENIE_DESC"],
					get		= function() return db.options.alerts.screenie end,
					set		= function() db.options.alerts.screenie = not db.options.alerts.screenie end,
				},
				superbuffnotify = {
					order	= 47,
					type	= "toggle",
					name	= L["Turn off Superbuff Alerts"],
					desc	= L["ALERT_SUPERBUFF_TOGGLE"],
					get		= function() return db.options.alerts.superbuffnotify end,
					set		= function() db.options.alerts.superbuffnotify = not db.options.alerts.superbuffnotify end,
				},
				header2 = {
					order	= 50,
					type	= "header",
					name	= L["Parrot Integration"],
					disabled	= function() return not ( Parrot ~= nil ) end,
				},
				desc2 = {
					order	= 51,
					type	= "description",
					name	= L["ALERT_PARROT_DESC"],
					disabled	= function() return not ( Parrot ~= nil ) end,
				},
				useParrot = {
					order	= 52,
					type	= "toggle",
					name	= L["Alert in Parrot Scroll Area"],
					desc	= L["ALERT_PARROTAREA_DESC"],
					get		= function() return db.options.alerts.useparrot end,
					set		= function() db.options.alerts.useparrot = not db.options.alerts.useparrot end,
					disabled	= function() return not ( Parrot ~= nil ) end,
				},
				parrotArea = {
					order	= 53,
					type	= "select",
					name	= L["Select Parrot Scroll Area"],
					desc	= L["ALERT_SELECTPARROTAREA_DESC"],
					get		= function() return db.options.alerts.parrotarea end,
					set		= function( info, value ) db.options.alerts.parrotarea = value end,
					values	= function()
						if ( Parrot ~= nil ) then
							return Parrot.GetScrollAreasChoices()
						else
							return {}
						end
					end,
					disabled	= function()
						if ( Parrot ~= nil ) then
							return not db.options.alerts.useparrot
						else
							return true
						end
					end,
				},
				header3 = {
					order	= 60,
					type	= "header",
					name	= L["MSBT Integration"],
					disabled	= function() return not ( MikSBT ~= nil ) end,
				},
				desc3 = {
					order	= 61,
					type	= "description",
					name	= L["ALERT_MSBT_DESC"],
					disabled	= function() return not ( MikSBT ~= nil ) end,
				},
				useMSBT = {
					order	= 62,
					type	= "toggle",
					name	= L["Alert in MSBT Scroll Area"],
					desc	= L["ALERT_MSBTAREA_DESC"],
					get		= function() return db.options.alerts.usemsbt end,
					set		= function() db.options.alerts.usemsbt = not db.options.alerts.usemsbt end,
					disabled	= function() return not ( MikSBT ~= nil ) end,
				},
				msbtArea = {
					order	= 63,
					type	= "select",
					name	= L["Select MSBT Scroll Area"],
					desc	= L["ALERT_SELECTMSBTAREA_DESC"],
					get		= function() return db.options.alerts.msbtarea end,
					set		= function( info, value ) db.options.alerts.msbtarea = value end,
					values	= function()
						if ( MikSBT ~= nil ) then
							local t = {}
							for k, v in MikSBT.IterateScrollAreas() do
								t[k] = v
							end
							return t
						else
							return {}
						end
					end,
					disabled	= function()
						if ( MikSBT ~= nil ) then
							return not db.options.alerts.usemsbt
						else
							return true
						end
					end,
				},
			},
		}
	end
	return alertOptions
end

local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["General Information"],
					desc	= L["GENERAL_INFO_DESC"],
					args	= {
						header1 = {
							order	= 11,
							type	= "header",
							name	= L["General Information"],
						},
						desc = {
							order	= 12,
							type	= "description",
							name	= L["GENERAL_INFO_DESC"],
						},
						author = {
							order	= 13,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 14,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 15,
							type	= "description",
							name	= L["Build Date : "] .. builddate .. "\n",
						},
						dbversion = {
							order	= 15,
							type	= "description",
							name	= L["Database Version : "] .. db.options.display.dbVersion .. "\n",
						},
						translators = {
							order	= 16,
							type	= "description",
							name	= string.format( L["Helpful Translators (thank you) : %s"], "SunTsu(deDE), Markam(frFR), next96(koKR)" ) .. "\n",
						},
					},
				},
			},
		}
	end
	
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end

	return options
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")

	-- Fill up our modular options...
	self:RegisterModuleOptions("Tracking", giveTracking(), L["Tracking Options"])
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
	self:RegisterModuleOptions("Alert", giveAlert(), L["Alert Options"])
end

function addon:setToggles()
	local tdb = db.options.tracking.damage
	local result = true
	for k, v in pairs( spellSchools ) do
		if ( tdb[k] == false ) then
			result = false
			break
		end
	end
	HitCrit.dmgToggleAll = result
	tdb = db.options.tracking.healing
	result = true
	for k, v in pairs( spellSchools ) do
		if ( tdb[k] == false ) then
			result = false
			break
		end
	end
	HitCrit.healToggleAll = result
end

function addon:populateSuperBuffs()
	for k, v in pairs( superBuffIDs ) do
		sName = GetSpellInfo( k )
		superBuffNames[sName] = true
	end
end

function addon:checkSuperBuffs()
	HitCrit_Debug( "checking superbuffs" )
	-- UnitControllingVehicle ?? UnitHasVehicleUI?? UnitInVehicle
	-- do superbuff checks
	local prevState = addon.superBuffed 
	addon.superBuffed = false
	local i = 1
	while ( true ) do
		local name, _, texture = UnitBuff( "player", i )
		-- if texture is nil, we're past the end of the buffs
		if not texture then break end
		if ( superBuffNames[ name ] == true ) then
			addon.superBuffed = true
			break
		end
		i = i + 1
	end
	if ( addon.superBuffed == true ) then
		HitCrit:UnregisterEvent( "COMBAT_LOG_EVENT_UNFILTERED" )
		if ( ( prevState == false ) and ( db.options.alerts.superbuffnotify == false ) ) then
			HitCrit_Print( L["You are now superbuffed (doing higher than normal damage). HitCrit disabled."] )
		end
	else
		HitCrit:RegisterEvent( "COMBAT_LOG_EVENT_UNFILTERED" )
		if ( ( prevState == true ) and ( db.options.alerts.superbuffnotify == false ) ) then
			HitCrit_Print( L["You are no longer superbuffed. HitCrit re-enabled."] )
		end
	end
	-- do vehicle checks
	prevState = addon.inVehicle
	addon.inVehicle = false
	if ( UnitInVehicle( "player" ) ) then
		addon.inVehicle = true
	end
	if ( addon.inVehicle == true ) then
		HitCrit:UnregisterEvent( "COMBAT_LOG_EVENT_UNFILTERED" )
		if ( ( prevState == false ) and ( db.options.alerts.superbuffnotify == false ) ) then
			HitCrit_Print( L["You are now in a vehicle (doing higher than normal damage). HitCrit disabled."] )
		end
	else
		if ( addon.superBuffed == true ) then
			HitCrit:UnregisterEvent( "COMBAT_LOG_EVENT_UNFILTERED" )
			if ( ( prevState == true ) and ( db.options.alerts.superbuffnotify == false ) ) then
				HitCrit_Print( L["You are no longer in a vehicle, but are still superbuffed. HitCrit remains disabled."] )
			end
		else
			HitCrit:RegisterEvent( "COMBAT_LOG_EVENT_UNFILTERED" )
			if ( ( prevState == true ) and ( db.options.alerts.superbuffnotify == false ) ) then
				HitCrit_Print( L["You are no longer in a vehicle. HitCrit re-enabled."] )
			end
		end
	end
end

function HitCrit:UNIT_AURA( ... )
	HitCrit_Debug( "Player unit aura event fired" )
	HitCrit:checkSuperBuffs()
end

function HitCrit:UNIT_ENTERED_VEHICLE( ... )
	HitCrit_Debug( "Unit entered vehicle event fired" )
	HitCrit:checkSuperBuffs()
end

function HitCrit:UNIT_EXITED_VEHICLE( ... )
	HitCrit_Debug( "Unit exited vehicle event fired" )
	HitCrit:checkSuperBuffs()
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function HitCrit:ShowConfig()
	-- Open the profiles tab before, so the menu expands
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

function HitCrit_ResetData()
	-- If we're here, the user already confirmed. Nuke away...
	if ( HitCrit.resetType == 1 ) then
		-- Reset all data for this toon
		-- Don't actually have a way to reach this anymore...
	elseif ( HitCrit.resetType == 2 ) then
		-- Reset all data either in "damage" or "heal"
		if ( HitCrit.selCategory == 1 ) then
			db.values.damage = nil
			db.values.damage = {}
		else
			db.values.heal = nil
			db.values.heal = {}
		end
	elseif ( HitCrit.resetType == 3 ) then
		-- Reset all "damage" or "heal" data for a specific school
		local dbc = {}
		if ( HitCrit.selCategory == 1 ) then
			dbc = db.values.damage
		else
			dbc = db.values.heal
		end
		for k, v in pairs( dbc ) do
			if ( v.school == HitCrit.selSchool ) then
				dbc[k] = nil
			end
		end
	elseif ( HitCrit.resetType == 4 ) then
		-- Reset specific spell entries (or whole entry)
		local dbc = {}
		if ( HitCrit.selCategory == 1 ) then
			dbc = db.values.damage
		else
			dbc = db.values.heal
		end
		if ( HitCrit.selType == "all" ) then
			dbc[ HitCrit.selEntry ] = nil
		else
			local entry = dbc[ HitCrit.selEntry ]
			local hTable = HitCrit.selType
			entry[ hTable ][1].value = entry[ hTable ][2].value
			entry[ hTable ][1].name = entry[ hTable ][2].name
			entry[ hTable ][2].value = entry[ hTable ][3].value
			entry[ hTable ][2].name = entry[ hTable ][3].name
			entry[ hTable ][3].value = 0
			entry[ hTable ][3].name = ""
		end
	end

	HitCrit.selCategory = 0
	HitCrit.selSchool = 0
	HitCrit.selType = 0
	HitCrit.selSpecific = 0

	HitCrit:ChangeLabel()
end

function HCBF_ResetCategoryButton()
	HideTooltip()
	HitCrit.resetType = 2
	local c = ""
	if ( HitCrit.selCategory == 1 ) then c = L["Damage"] else c = L["Heal"] end
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset Category: %s. Are you sure?"], c )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HCBF_ResetSchoolButton()
	HideTooltip()
	HitCrit.resetType = 3
	local c = ""
	if ( HitCrit.selCategory == 1 ) then c = L["Damage"] else c = L["Heal"] end
	local s = spellSchools[ HitCrit.selSchool ]
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset Category: %s, School: %s. Are you sure?"], c, s )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HCBF_ResetEntryButton()
	HideTooltip()
	HitCrit.resetType = 4
	local e = HitCrit.selEntryName
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset all entries for spell: %s. Are you sure?"], e )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HCBF_ResetTopEntryButton()
	HideTooltip()
	HitCrit.resetType = 4
	local e = HitCrit.selEntryName
	local t = HitCrit.selType
	StaticPopupDialogs["HC_CONFIRM_RESET_DATA"].text =
		string.format( L["Reset first %s entry for spell: %s. Are you sure?"], t, e )
	StaticPopup_Show( "HC_CONFIRM_RESET_DATA" )
end

function HitCrit:OnInitialize()
	-- If there was frame creation stuff to do, it would go here
end

function HitCrit:OnEnable()
    -- Called when the addon is loaded
	HitCrit.me = UnitName( "player" )
	HitCrit.GUID = UnitGUID( "player" )
	HitCrit.level = UnitLevel( "player" )

	self.db = LibStub( "AceDB-3.0" ):New( "HitCrit_DB", nil, "Default" )
	-- do we have any data yet; for this toon? If not, init its table
	if not ( self.db.factionrealm[HitCrit.me] ) then
		self.db.factionrealm[HitCrit.me] = {
			options = {
				tracking = {
					pvp = false,
					againstMe = false,
					environmental = false,
					vulnerable = false,
					lowlevel = false,
					damage = true,
					spdetect = true,
					healing = {
						[1]		= true, -- physical
						[2]		= true,	-- holy
						[4]		= true,	-- fire
						[8]		= true,	-- nature
						[16]	= true,	-- frost
						[20]	= true, -- frostfire
						[24]	= true,	-- froststorm
						[32]	= true,	-- shadow
						[40]	= true,	-- shadowstorm
						[64]	= true, -- arcane
					},
					damage = {
						[1]		= true, -- physical
						[2]		= true,	-- holy
						[4]		= true,	-- fire
						[8]		= true,	-- nature
						[16]	= true,	-- frost
						[20]	= true, -- frostfire
						[24]	= true,	-- froststorm
						[32]	= true,	-- shadow
						[40]	= true,	-- shadowstorm
						[64]	= true, -- arcane
					},
				},
				display = {
					hit = true,
					crit = true,
					avg = true,
					enemyName = false,
					type = false,
					debug = false,
					tipscale = 1,
					dbVersion = "2.5",
					label = false,
					labelHeal = false,
					labelDmg = false,
					autoHideDelay = .1,
				},
				alerts = {
					sound = false,
					notify = false,
					chatframe = true,
					screenie = false,
					superbuffnotify = false,
					useparrot = false,
					parrotarea = "",
					usemsbt = false,
					msbtarea = "",
				},
			},
			values = {
				damage = {},
				heal = {},
			}
		}
	else
		-- check if we need to upgrade the db
		HitCrit_upgradeDB()
	end
	db = self.db.factionrealm[HitCrit.me]

	HitCrit_Debug( "In OnInit" )

	HitCrit:setToggles()
	HitCrit:SetupOptions()
	HitCrit:ChangeLabel()

	HitCrit:populateSuperBuffs()
	-- Event listeners
    HitCrit:RegisterEvent( "COMBAT_LOG_EVENT_UNFILTERED" )
	-- Toggle if we're not detecting superbuffs/vehicles
	if ( db.options.tracking.spdetect ~= true ) then
		HitCrit:RegisterEvent( "UNIT_AURA" )
		HitCrit:RegisterEvent( "UNIT_ENTERED_VEHICLE" )
		HitCrit:RegisterEvent( "UNIT_EXITED_VEHICLE" )
		HitCrit:checkSuperBuffs()
	end
end

--[[
************************************************************************
CHANGELOG:

Date : 8/6/09
	Updated new Libqtip (which contains scripting)
	Removed libqtipclick
	updated toc to 3.2 (30200)
	adding option for tooltip delay (and slider to adjust)
Date : 5/31/09
	Removed data reset thinger in favor of using libqtipclick
	Added Libqtipclick support
	added reporting into chatframe support
Date : 4/15/09
	added ability to turn off the superbuff notifications in chat
Date : 12/02/08
	added ability display top hit/crit values in text of display
Date : 11/17/08
	added data browser and the ability to remove data points
Date : 11/15/08
	changed font size to tooltip scaling in options == win
Date : 10/29/08
	Initial version
************************************************************************
]]--